/* bxVector.h */

#include "../bxCore.h"


class CbxVector {
	public:
		static bool
		Pos( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double pos[ 4 ][ 3 ] );
		static void
		Pos0( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double pos[ 3 ] );
		static bool
		Pos1( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double pos[ 3 ] );
		static bool
		Pos2( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double pos[ 3 ] );
		static void
		Pos3( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double pos[ 3 ] );
		static bool
		Handle( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 4 ][ 3 ] );
		static bool
		Handle0( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ] );
		static bool
		Handle1( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ] );
		static bool
		Handle2( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ] );
		static bool
		Handle3( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ] );
		static bool
		AntiHandle( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 4 ][ 3 ] );
		static bool
		AntiHandle0( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ] );
		static bool
		AntiHandle1( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ] );
		static bool
		AntiHandle2( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ] );
		static bool
		AntiHandle3( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ] );
		static bool
		Tan( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ][ 3 ] );
		static bool
		Tan0( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ] );
		static bool
		Tan1( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ] );
		static bool
		Tan2( const short no, const short numVertex, const CbxCore::SurfaceForPickVertex vertex[], double vec[ 3 ] );
		static void
		Pos0ForCtlVecForDefault( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex vertex[],
			double pos[ 3 ] );
		static bool
		Pos1ForCtlVecForDefault( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex vertex[],
			double pos[ 3 ] );
		static bool
		Pos2ForCtlVecForDefault( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex vertex[],
			double pos[ 3 ] );
		static void
		Pos3ForCtlVecForDefault( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex vertex[],
			double pos[ 3 ] );
		static bool
		Handle1ForCtlVecForDefault( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex in[],
			const CbxCore::CtlVecForDefaultOutVertex out[], double vec[ 3 ] );
		static bool
		Handle2ForCtlVecForDefault( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex in[],
			const CbxCore::CtlVecForDefaultOutVertex out[], double vec[ 3 ] );
		static bool
		Tan0ForCtlVecForDefault( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex vertex[],
			double vec[ 3 ] );
		static bool
		Tan2ForCtlVecForDefault( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex vertex[],
			double vec[ 3 ] );
		static bool
		GetDefaultCtlVec( const double posVec[ 3 ], const double srcCtlVec[ 3 ], double dstCtlVec[ 3 ] );
		static bool
		GetDefaultHandle( const double radialVec[ 3 ], const double tanE[ 3 ], double tan[ 3 ] );
		static bool
		SetHandle1( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex in[],
			const double vec[ 3 ], CbxCore::CtlVecForDefaultOutVertex out[] );
		static bool
		SetHandle2( const short no, const short numVertex, const CbxCore::CtlVecForDefaultInVertex in[],
			const double vec[ 3 ], CbxCore::CtlVecForDefaultOutVertex out[] );
		static bool
		ElementAxisInCtlVecPlus( const CbxCore::CtlVecForTransSub sub[ 2 ], const double ctlPlaneDeg,
			double axis[ 2 ][ 3 ], double* lenBaseCtlVec );

	private:
		static bool
		IsLongerRadius( const double radialVec[ 3 ], const double tanE[ 3 ] );
		static void
		GetDefaultHandleLonger( const double radialVec[ 3 ], const double tanE[ 3 ], double tan[ 3 ] );
		static bool
		GetDefaultHandleShorter( const double radialVec[ 3 ], const double tanE[ 3 ], double tan[ 3 ] );

	private:
		static const double  minSinForShorterRadius;
};
