/* BeziexView.h */

#if !defined( BEZIEX_VIEW_H )
	#define  BEZIEX_VIEW_H


	#include "resource.h"

	#include "../Beziex/Math/bxMath.h"
	#include "../Beziex/DataBase/bxDB.h"
	#include "../Beziex/Proc/bxProc.h"
	#include "../Beziex/Util/bxUtil.h"
	#include "../Beziex/Core/bxCore.h"

	#include "Main/bvMain.h"
	#include "Main/bvMenu.h"
	#include "Main/bvDlog.h"
	#include "Main/bvPaint.h"

	#include "File/bvRead.h"
	#include "File/bvReadCore.h"
	#include "File/bvAfterRead.h"

	#include "Polygon/bvPolygon.h"
	#include "Edge/bvEdge.h"

	#include "OpenGL/bvGL.h"
	#include "OpenGL/bvGLwire.h"
	#include "OpenGL/bvGLelement.h"
	#include "OpenGL/bvGLsurf.h"
	#include "OpenGL/bvGLmesh.h"


#endif
