/* bvEdge.h */


class CbvEdge {
	public:
		enum {
			numLineOnEdge	= 8
		};

	public:
		struct LineRec {
			double  vertex[ 2 ][ 3 ];
		};

	public:
		static bool
		Update( void );
		static void
		FreeData( void );

	private:
		static bool
		Alloc( void );
		static bool
		Proc( bool ( *Exec )( const ulong edgeNo, const ulong lineNo, bool* dispChk ) );
		static bool
		ProcMain( const ulong edgeNo, bool ( *Exec )( const ulong edgeNo, const ulong lineNo, bool* dispChk ) );
		static bool
		FuncDispChk( const ulong edgeNo, const ulong lineNo, bool* dispChk );
		static bool
		AllocData( void );
		static void
		SetEdge( void );
		static bool
		FuncSetEdge( const ulong edgeNo, const ulong lineNo, bool* dispChk );
		static void
		SetLine( const ulong edgeNo, const double bezierLine[ 4 ][ 3 ] );
	
	public:
		static ulong     numLineAry;
		static LineRec*  lineAry;
};
