/* bvMain.h */

#include <windows.h>


class CbvMain {
	private:
		enum {
			winInitSizeX	= 600,
			winInitSizeY	= 300
		};

	public:
		static int
		Main( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow );
		static HINSTANCE
		HInst( void )		{  return( hInst );  }
		static void
		FinishProc( void );

	private:
		static LRESULT CALLBACK
		WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
		static void
		InitWin( HWND hWnd );
		static void
		InitPalette( void );
		static void
		PaletteProc( const UINT uMsg, HWND hFocusWnd );
		static int
		GetNonClientWidth( void );
		static int
		GetNonClientHeight( void );
		static void
		CreateProc( HWND hWnd );

	private:
		static HINSTANCE  hInst;
		static HPALETTE   hPalette;
};
