/* bvGLsurf.cpp */

#include "../BeziexView.h"


void  CbvGLsurf::
Draw( HWND hWnd )
{
	glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
	glEnable( GL_DEPTH_TEST );

	glEnable( GL_LIGHTING );

	SetMaterial();
	DrawPolygon();
}


void  CbvGLsurf::
SetMaterial( void )
{
	GLfloat  data[ 4 ];

	data[ 0 ] = 1.0;	data[ 1 ] = 0.0;	data[ 2 ] = 0.0;	data[ 3 ] = 0.0;	
	glMaterialfv( GL_FRONT, GL_AMBIENT_AND_DIFFUSE, data );

	data[ 0 ] = 0.0;	data[ 1 ] = 0.0;	data[ 2 ] = 1.0;	data[ 3 ] = 0.0;	
	glMaterialfv( GL_BACK, GL_AMBIENT_AND_DIFFUSE, data );

	data[ 0 ] = 1.0;	data[ 1 ] = 1.0;	data[ 2 ] = 1.0;	data[ 3 ] = 0.0;	
	glMaterialfv( GL_FRONT_AND_BACK, GL_SPECULAR, data );

	data[ 0 ] = 0.0;	data[ 1 ] = 0.0;	data[ 2 ] = 0.0;	data[ 3 ] = 0.0;	
	glMaterialfv( GL_FRONT_AND_BACK, GL_EMISSION, data );

	data[ 0 ] = 70.0;
	glMaterialfv( GL_FRONT_AND_BACK, GL_SHININESS, data );
}


void  CbvGLsurf::
DrawPolygon( void )
{
	ulong  i;
	short  j;

	for( i=0; i<CbvPolygon::numPolygonAry; i++ ) {
		glBegin( GL_TRIANGLES );
			for( j=0; j<3; j++ ) {
				glNormal3f( ( GLfloat )CbvPolygon::polygonAry[ i ].vertex[ j ].normal[ 0 ],
				            ( GLfloat )CbvPolygon::polygonAry[ i ].vertex[ j ].normal[ 1 ],
				            ( GLfloat )CbvPolygon::polygonAry[ i ].vertex[ j ].normal[ 2 ] );
				glVertex3f( ( GLfloat )CbvPolygon::polygonAry[ i ].vertex[ j ].pos[ 0 ],
				            ( GLfloat )CbvPolygon::polygonAry[ i ].vertex[ j ].pos[ 1 ],
				            ( GLfloat )CbvPolygon::polygonAry[ i ].vertex[ j ].pos[ 2 ] );
			}
		glEnd();
	}
}
