/* bvGLwire.cpp */

#include "../BeziexView.h"


void  CbvGLwire::
Draw( HWND hWnd )
{
	glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
	glEnable( GL_DEPTH_TEST );

	glDisable( GL_LIGHTING );

	SetMaterial();
	DrawEdge();
}


void  CbvGLwire::
SetMaterial( void )
{
	glColor3f( 0.5f, 0.5f, 0.5f );
	glLineWidth( 1.0 );
}


void  CbvGLwire::
DrawEdge( void )
{
	ulong  i;
	short  j;

	for( i=0; i<CbvEdge::numLineAry; i++ ) {
		glBegin( GL_LINES );
			for( j=0; j<2; j++ ) {
				glVertex3f( ( GLfloat )CbvEdge::lineAry[ i ].vertex[ j ][ 0 ],
					        ( GLfloat )CbvEdge::lineAry[ i ].vertex[ j ][ 1 ],
					        ( GLfloat )CbvEdge::lineAry[ i ].vertex[ j ][ 2 ] );
			}
		glEnd();
	}
}
