/* bxElement.h */

#include "../bxCore.h"


class CbxElement {
	public:
		static void
		AxisInCtlPlaneDeg( const double vertexPosOrg[ 3 ], const double handleVecOrg[ 3 ], const double handleVecRadial[ 3 ],
			const double vertexPosRadial[ 3 ], double axisOrg[ 3 ] );
		static void
		CrossBoundOnVertex( const double wingHandleVec[ 2 ][ 3 ], double crossBoundOnVertex[ 3 ] );
		static void
		DefaultNormalInCtlPlaneDeg( const double normalOrgOnVertex[ 3 ], const double axisOrgInCtlPlaneDeg[ 3 ],
			const double normalRadialOnVertex[ 3 ], double normalInCtlPlaneDeg[ 3 ] );
		static void
		SubAxisInCtlPlaneDeg( const double axisInCtlPlaneDeg[ 3 ], const double defaultNormalInCtlPlaneDeg[ 3 ],
			double subAxisInCtlPlaneDeg[ 3 ] );
		static bool
		BaseCtlVec( const double handleVec[ 2 ][ 3 ], const double crossBoundOnVertex[ 2 ][ 3 ],
			const double normalInCtlPlaneDeg[ 3 ], const double axisInCtlPlaneDeg[ 3 ], double ctlVec[ 3 ] );
};


class CbxElementEx {
	public:
		static bool
		ElementOnCtlVec( const CbxCore::CtlVecForTransSub sub[ 2 ], const double ctlPlaneDeg, double handleVec[ 2 ][ 3 ],
			double crossBoundOnVertex[ 2 ][ 3 ], double axisInCtlPlaneDeg[ 3 ], double normalInCtlPlaneDeg[ 3 ] );
		static bool
		ElementAxisInCtlVec( const CbxCore::CtlVecForTrans* ctl, double axis[ 2 ][ 3 ], double* lenBaseCtlVec );
};
