/* bxOrgTo3D.h */

#include "../bxCore.h"


class CbxOrgTo3D {
	public:
		static bool
		HandleVec( const double axisVec[ 2 ][ 3 ], const double lenRadialVec, const double iHandleVec[ 2 ],
			double oHandleVec[ 3 ] );
		static bool
		NormalInCtlPlaneDeg( const double axisInCtlPlaneDeg[ 3 ], const double defaultNormalInCtlPlaneDeg[ 3 ],
			const double ctlPlaneDeg, double normalInCtlPlaneDeg[ 3 ] );
		static bool
		CtlVec( const double axisVec[ 2 ][ 3 ], const double lenBaseCtlVec, const double iCtlVec[ 2 ], double oCtlVec[ 3 ] );
};


class CbxOrgTo3Dex {
	public:
		static bool
		GetHandle( const CbxCore::HandleForTrans* handle, double handleVec[ 3 ] );
		static bool
		GetCtlInCtlVec( const CbxCore::CtlVecForTrans* ctl, double ctlVec[ 3 ] );
};
