/* bvMenu.cpp */

#include "../BeziexView.h"


void  CbvMenu::
Proc( HWND hWnd, const WORD id )
{
	switch( id ) {
		case IDM_EXIT:
			DestroyWindow( hWnd );
			break;

		case IDM_ROTSURFX:
			if( CbvDlogRotSurfX::Proc( hWnd ) == IDOK )
				InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_ROTSURFY:
			if( CbvDlogRotSurfY::Proc( hWnd ) == IDOK )
				InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_ROTSURFZ:
			if( CbvDlogRotSurfZ::Proc( hWnd ) == IDOK )
				InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_DIRSTD:
			CbvGL::SetDirStd();
			InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_DIRTOP:
			CbvGL::SetDirTop();
			InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_DIRFRONT:
			CbvGL::SetDirFront();
			InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_DIRSIDE:
			CbvGL::SetDirSide();
			InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_SELVER:
			if( CbvDlogSelVer::Proc( hWnd ) == IDOK )
				InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_SELHAND:
			if( CbvDlogSelHand::Proc( hWnd ) == IDOK )
				InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_SELCTLBAR:
			if( CbvDlogSelCtlBar::Proc( hWnd ) == IDOK )
				InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_VERTEX:
			if( CbvDlogVertex::Proc( hWnd ) == IDOK )
				InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_HANDLE:
			if( CbvDlogHandle::Proc( hWnd ) == IDOK )
				InvalidateRect( hWnd, NULL, TRUE );
			break;
		case IDM_CTLBAR:
			if( CbvDlogCtlBar::Proc( hWnd ) == IDOK )
				InvalidateRect( hWnd, NULL, TRUE );
			break;
	}
}
