/* bvPaint.cpp */

#include "../BeziexView.h"


void  CbvPaint::
Paint( HWND hWnd, HDC hDC )
{
	bool  result;

	result = CbxProc::ErrChk();
	if( result == true ) {
		CbvMessage::Error( IDS_CANNOTCONTINUE );
		return;
	}

	CbvGL::Paint( hWnd, hDC );
	DrawCenterVBound( hWnd, hDC );
}


void  CbvPaint::
DrawCenterVBound( HWND hWnd, HDC hDC )
{
	int   sx, sy, ex, ey;
	HPEN  hPen, hOldPen;
	RECT  rect;

	GetClientRect( hWnd, &rect );
	sx = ex = rect.right / 2;
	sy = 0;
	ey = rect.bottom;

	hPen    = CreatePen( PS_SOLID, 1, RGB( 0, 0, 0 ) );
	hOldPen = ( HPEN )SelectObject( hDC, hPen );

	MoveToEx( hDC, sx, sy, NULL );
	LineTo( hDC, ex, ey );

	SelectObject( hDC, hOldPen );
	DeleteObject( hPen );
}
