/* bvGLmesh.h */

#include <windows.h>
#include <gl\gl.h>


class CbvGLmesh {
	private:
		enum {
			numMeshLine = 11
		};

	public:
		static void
		Draw( void );

	private:
		static void
		DrawMesh( void );
		static void
		DrawMeshX( const double depth );
		static void
		DrawMeshXsub( const double sx, const double inc, const double y[ 2 ], const double depth, const short num );
		static void
		DrawMeshY( const double depth );
		static void
		DrawMeshYsub( const double sy, const double inc, const double x[ 2 ], const double depth, const short num );
		static void
		DrawMeshZ( const double depth );
		static void
		DrawMeshZsub( const double x, const double y, const double depth );

	private:
		static const double  meshSize;
		static const double  meshDepth;
		static const double  lenMeshZ;
};
